/**
 * @author Elias Villiger <elias.villiger@uzh.ch>
 */

/* global $ */
/* global EventEmitter */
/* @depend QfqEvents.js */

$(document).ready( function () {
    $.tablesorter.themes.bootstrap.table = "";

    $('.tablesorter').each(function(i) {
        var hasFilter = $(this).hasClass('tablesorter-filter');
        var hasPager = $(this).hasClass('tablesorter-pager');
        var hasColumnSelector = $(this).hasClass('tablesorter-column-selector');

        var columnSelectorId = "qfq-column-selector-" + i;
        var columnSelectorTargetId = "qfq-column-selector-target-" + i;
        var pagerId = "qfq-pager-" + i;

        var tablesorterConfig = $(this).data("tablesorterConfig");
        if (!tablesorterConfig) { // revert to default
            tablesorterConfig = {
                theme: "bootstrap",
                widthFixed: true,
                headerTemplate: "{content} {icon}",
                dateFormat: "ddmmyyyy",
                widgets: ["uitheme", "filter", "saveSort", "columnSelector"],
                widgetOptions: {
                    filter_columnFilters: hasFilter, // turn filters on/off with true/false
                    filter_reset: ".reset",
                    filter_cssFilter: "form-control",
                    columnSelector_mediaquery: false
                } };
        }

        $(this).tablesorter(tablesorterConfig);

        if (hasColumnSelector) {
            var columnSelectorHtml = '<div class="qfq-column-selector-wrapper"><button id="' + columnSelectorId + '" class="btn btn-default qfq-column-selector" ' +
                'type="button">' +
                '<span class="dropdown-text"><span class="icon glyphicon glyphicon-th-list"></span></span>' +
                '<span class="caret"></span></button>' +
                '<div class="hidden"><div id="' + columnSelectorTargetId + '" class="qfq-column-selector-target"> </div></div></div>';
            $(columnSelectorHtml).insertBefore($(this));
            $.tablesorter.columnSelector.attachTo($(this), '#' + columnSelectorTargetId);
            $('#' + columnSelectorId).popover({
                placement: 'left',
                html: true, // required if content has HTML
                content: $('#' + columnSelectorTargetId)
            });
        }

        if (hasPager) {
            var pagerHtml = '<div id="' + pagerId + '" class="form-inline" style="margin-top:-20px; margin-bottom:20px;">' +
                '<div class="btn-group btn-group-sm" role="group">' +
                '<button type="button" class="btn btn-default first"><span class="glyphicon glyphicon-step-backward"></span></button>' +
                '<button type="button" class="btn btn-default prev"><span class="glyphicon glyphicon-backward"></span></button>' +
                '</div><span class="pagedisplay"></span>' +
                '<div class="btn-group btn-group-sm" role="group">' +
                '<button type="button" class="btn btn-default next"><span class="glyphicon glyphicon-forward"></span></button>' +
                '<button type="button" class="btn btn-default last"><span class="glyphicon glyphicon-step-forward"></span></button>' +
                '</div>' +
                '<select class="form-control input-sm pagesize" title="Select page size">' +
                '<option selected="selected" value="10">10</option>' +
                '<option value="25">25</option>' +
                '<option value="50">50</option>' +
                '<option value="100">100</option>' +
                '<option value="all">All Rows</option>' +
                '</select>' +
                '<select class="form-control input-sm pagenum" title="Select page number"></select>' +
                '</div>';
            $(pagerHtml).insertAfter($(this));
            $(this).tablesorterPager({
                container: $("#" + pagerId),
                cssGoto: ".pagenum",
                removeRows: false,
                output: '{startRow} - {endRow} / {filteredRows}'
            });
        }
    }); // end .each()
} );